// Questo codice sorgente degli esempi di MFC illustra l'utilizzo dell'interfaccia utente Microsoft Office Fluent di MFC 
// e viene fornito esclusivamente come riferimento in supplemento 
// al materiale di riferimento e alla documentazione in formato elettronico MFC 
// forniti con il software della libreria MFC C++.  
// Le condizioni di licenza per la copia, l'utilizzo o la distribuzione dell'interfaccia utente Microsoft Office Fluent sono disponibili separatamente.  
// Per ulteriori informazioni sul programma di licenza dell'interfaccia utente Microsoft Office Fluent, visitare il sito 
// http://go.microsoft.com/fwlink/?LinkId=238214.
//
// Copyright (C) Microsoft Corporation
// Tutti i diritti riservati.

// MFCApplication.cpp : definisce i comportamenti delle classi per l'applicazione.
//

#include "stdafx.h"
#include "afxwinappex.h"
#include "afxdialogex.h"
#include "MFCApplication.h"
#include "MainFrm.h"

#include "MFCApplicationDoc.h"
#include "MFCApplicationView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CMFCApplicationApp

BEGIN_MESSAGE_MAP(CMFCApplicationApp, CWinAppEx)
	ON_COMMAND(ID_APP_ABOUT, &CMFCApplicationApp::OnAppAbout)
	// Comandi di documenti basati su file standard
	ON_COMMAND(ID_FILE_NEW, &CWinAppEx::OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, &CWinAppEx::OnFileOpen)
	// Comando di stampa standard
	ON_COMMAND(ID_FILE_PRINT_SETUP, &CWinAppEx::OnFilePrintSetup)
END_MESSAGE_MAP()


// costruzione di CMFCApplicationApp

CMFCApplicationApp::CMFCApplicationApp()
{
	m_bHiColorIcons = TRUE;

	// supporto Gestione riavvio
	m_dwRestartManagerSupportFlags = AFX_RESTART_MANAGER_SUPPORT_ALL_ASPECTS;
#ifdef _MANAGED
	// Se l'applicazione  compilata mediante il supporto CLR (/clr):
	//     1) Questa ipostazione  necessaria per il corretto funzionamento del supporto di Gestione riavvio.
	//     2) Nel progetto  necessario aggiungere un riferimento a System.Windows.Forms per eseguire la compilazione.
	System::Windows::Forms::Application::SetUnhandledExceptionMode(System::Windows::Forms::UnhandledExceptionMode::ThrowException);
#endif

	// TODO: sostituire la stringa dell'ID applicazione seguente con una stringa di ID univoca; il formato consigliato
	// per la stringa  NomeSociet.NomeProdotto.Sottoprodotto.Versione
	SetAppID(_T("MFCApplication.AppID.NoVersion"));

	// TODO: aggiungere qui il codice di costruzione.
	// Inserire l'inizializzazione significativa in InitInstance.
}

// L'unico e solo oggetto CMFCApplicationApp

CMFCApplicationApp theApp;


// Inizializzazione di CMFCApplicationApp

BOOL CMFCApplicationApp::InitInstance()
{
	// InitCommonControlsEx()  necessario in Windows XP se nel manifesto
	// di un'applicazione  specificato l'utilizzo di ComCtl32.dll versione 6 o successiva per abilitare
	// gli stili visuali.  In caso contrario, non sar possibile creare finestre.
	INITCOMMONCONTROLSEX InitCtrls;
	InitCtrls.dwSize = sizeof(InitCtrls);
	// Effettuare questa impostazione in modo da includere tutte le classi di controlli comuni da utilizzare
	// nell'applicazione.
	InitCtrls.dwICC = ICC_WIN95_CLASSES;
	InitCommonControlsEx(&InitCtrls);

	CWinAppEx::InitInstance();


	// Inizializzare le librerie OLE.
	if (!AfxOleInit())
	{
		AfxMessageBox(IDP_OLE_INIT_FAILED);
		return FALSE;
	}

	AfxEnableControlContainer();

	EnableTaskbarInteraction(FALSE);

	// AfxInitRichEdit2()  necessario per utilizzare il controllo RichEdit	
	// AfxInitRichEdit2();

	// Inizializzazione standard
	// Se non si utilizzano queste funzionalit e si desidera ridurre la dimensione
	// dell'eseguibile finale,  necessario rimuovere dal seguente codice
	// le specifiche routine di inizializzazione che non sono necessarie.
	// Modificare la chiave del Registro di sistema in cui sono memorizzate le impostazioni
	// TODO:  necessario modificare questa stringa in modo appropriato,
	// inserendo ad esempio il nome della societ o dell'organizzazione.
	SetRegistryKey(_T("Applicazioni locali generate tramite la Creazione guidata applicazioni"));
	LoadStdProfileSettings(4);  // Caricare le opzioni del file INI standard (inclusa MRU).


	InitContextMenuManager();
	InitShellManager();

	InitKeyboardManager();

	InitTooltipManager();
	CMFCToolTipInfo ttParams;
	ttParams.m_bVislManagerTheme = TRUE;
	theApp.GetTooltipManager()->SetTooltipParams(AFX_TOOLTIP_TYPE_ALL,
		RUNTIME_CLASS(CMFCToolTipCtrl), &ttParams);

	// Registrare i modelli di documenti dell'applicazione.  I modelli di documenti
	//  funzionano da connessione tra documenti, finestre cornice e viste.
	CSingleDocTemplate* pDocTemplate;
	pDocTemplate = new CSingleDocTemplate(
		IDR_MAINFRAME,
		RUNTIME_CLASS(CMFCApplicationDoc),
		RUNTIME_CLASS(CMainFrame),       // finestra cornice SDI principale
		RUNTIME_CLASS(CMFCApplicationView));
	if (!pDocTemplate)
		return FALSE;
	AddDocTemplate(pDocTemplate);


	// Analizzare la riga di comando per i comandi shell standard, DDE, apri file
	CCommandLineInfo cmdInfo;
	ParseCommandLine(cmdInfo);

	// Abilitare apertura esecuzione DDE.
	EnableShellOpen();
	RegisterShellFileTypes(TRUE);


	// Invia i comandi specificati nella riga di comando.  Restituisce FALSE se
	// l'applicazione  stata avviata con l'opzione /RegServer, /Register, /Unregserver o /Unregister.
	if (!ProcessShellCommand(cmdInfo))
		return FALSE;

	// L'unica e sola finestra  stata inizializzata, quindi  possibile visualizzarla e aggiornarla.
	m_pMainWnd->ShowWindow(SW_SHOW);
	m_pMainWnd->UpdateWindow();
	// richiamare DragAcceptFiles solo se  presente un suffisso.
	//  In un'applicazione SDI questo deve verificarsi dopo ProcessShellCommand.
	// Abilitare il trascinamento della selezione.
	m_pMainWnd->DragAcceptFiles();
	return TRUE;
}

int CMFCApplicationApp::ExitInstance()
{
  CoUninitialize();
	//TODO: gestire le altre risorse eventualmente aggiunte.
	AfxOleTerm(FALSE);

	return CWinAppEx::ExitInstance();
}

// gestori dei messaggi di CMFCApplicationApp


// finestra di dialogo CAboutDlg utilizzata per visualizzare le informazioni sull'applicazione.

class CAboutDlg : public CDialogEx
{
public:
	CAboutDlg();

// Dati della finestra di dialogo
#ifdef AFX_DESIGN_TIME
	enum { IDD = IDD_ABOUTBOX };
#endif

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // supporto DDX/DDV

// Implementazione
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialogEx(IDD_ABOUTBOX)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialogEx)
END_MESSAGE_MAP()

// comando dell'applicazione per eseguire la finestra di dialogo
void CMFCApplicationApp::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}

// Metodi di caricamento/salvataggio personalizzazione di CMFCApplicationApp

void CMFCApplicationApp::PreLoadState()
{
	BOOL bNameValid;
	CString strName;
	bNameValid = strName.LoadString(IDS_EDIT_MENU);
	ASSERT(bNameValid);
	GetContextMenuManager()->AddMenu(strName, IDR_POPUP_EDIT);
}

void CMFCApplicationApp::LoadCustomState()
{
}

void CMFCApplicationApp::SaveCustomState()
{
}

// gestori dei messaggi di CMFCApplicationApp



